mod Ex02b logic: 'cl'

incl Mtex

incl Mtexg

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU M-INAA-046 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 1.3.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INAA-046-svp/0607ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane vyrokovo-logickemu 
  vyplyvaniu a logike s kvantifikatormi. 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Quantification Logic.  \end 

rem 
  \para \bf  Section. Quantification Tableaux.  \end 

rem 
  \para \bf  [CL] Tableaux quantifier rules.  \end Syntax: 
  \eq* 
    'inst [*] (<assumption> | <goal*>) ; <term>'
  \end
  \eq* 
    'eigen [*] (<assumption> | <goal*>) ; <eigen-variable>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_inst Tex_f2_g_x_sc(Tex_f2_g_forall(x,Tex2_bappl1(A,x)),
                                                 Tex0_tau) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_assum Tex_f2_g_forall(x,Tex2_bappl1(A,x)),
                            Tex_f1_g_x_assum Tex2_bappl1(A,Tex0_tau),
                            Tex_f1_g_x_assum(Tex_f0_g_forall))
         \end
   \item \para 
         \ft Tex_f1_g_x_eigeng Tex_f2_g_x_sc(Tex_f2_g_forall(x,Tex2_bappl1(A,x)),y) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_forall(x,Tex2_bappl1(A,x)),
                            Tex_f1_g_x_goal Tex2_bappl1(A,y),
                            Tex_f1_g_x_goal(Tex_f0_g_forall))
         \end
         \para where \ft y \end is a new variable \it  (eigen-variable)  \end 
   \item \para 
         \ft Tex_f1_g_x_eigen Tex_f2_g_x_sc(Tex_f2_g_exists(x,Tex2_bappl1(A,x)),y) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_assum Tex_f2_g_exists(x,Tex2_bappl1(A,x)),
                            Tex_f1_g_x_assum Tex2_bappl1(A,y),
                            Tex_f1_g_x_assum(Tex_f0_g_exists))
         \end
         \para where \ft y \end is a new variable \it  (eigen-variable)  \end 
   \item \para \ft Tex_f1_g_x_instg Tex_f2_g_x_sc(Tex_f2_g_exists(x,Tex2_bappl1(A,x)),
                                                  Tex0_tau) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_goal Tex_f2_g_exists(x,Tex2_bappl1(A,x)),
                            Tex_f1_g_x_goal Tex2_bappl1(A,Tex0_tau),
                            Tex_f1_g_x_goal(Tex_f0_g_exists))
         \end
  \end

theory Examples logic: 'fol_yeq_min'

pred A 

pred B 

rem 
  \para \bf  Exercise.  \end Prove the following sentences: 
  \eq* 
    \e x(A(x) & B(x)) -> \e xA(x) & \e xB(x)
  \end
  \eq* 
    \a xA(x) \/ \a xB(x) -> \a x(A(x) \/ B(x))
  \end
  \eq* 
    ~\e xA(x) <-> \a x~A(x)
  \end

thm Exists_and
  \e x(A(x) & B(x)) -> \e xA(x) & \e xB(x)

thm Forall_or
  \a xA(x) \/ \a xB(x) -> \a x(A(x) \/ B(x))

thm Not_exists
  ~\e xA(x) <-> \a x~A(x)

end theory Examples

theory Sm_drinker_paradox logic: 'fol_def'

appldisp/1 Tex_p2_g_dr
  Postfix(Arg(0),10,1,Op('is drinking',0))

pred Dr 'Tex_p2_g_dr'

rem 
  \para \bf  Exercise.  \end Prove the drinker paradox: 
  \items 
   \item \para There is someone in the pub such that, if he is drinking, then 
         everyone in the pub is drinking. 
  \end
  \para More formally, prove the following claim. 

thm Drinker_paradox
  \e y(Dr(y) -> \a xDr(x))
proof  proved.

end theory Sm_drinker_paradox

rem 
  \para \bf  [CL] Tableaux quantifier rules II.  \end Syntax: 
  \eq* 
    'inst [*] (<assumption> | <goal*>) ; <term(s)>'
  \end
  \eq* 
    'eigen [*] (<assumption> | <goal*>) ; <eigenvariable(s)>'
  \end
  \para Example(s): 
  \items 
   \item \para 
         \ft Tex_f1_g_x_inst Tex_f2_g_x_sc(Tex_f2_g_x_sc(Tex_f2_g_forall(x,
                                                                         Tex_f2_g_forall(y,
                                                                                         Tex3_bappl2(A,
                                                                                                     x,
                                                                                                     y))),
                                                         Tex0_tau),Tex0_rho) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_assum Tex_f2_g_forall(x,
                                                             Tex_f2_g_forall(y,
                                                                             Tex3_bappl2(A,
                                                                                         x,
                                                                                         y))),
                            Tex_f1_g_x_assum Tex3_bappl2(A,Tex0_tau,Tex0_rho),
                            Tex_f1_g_x_assum(Tex_f0_g_forall))
         \end
   \item \para \ft Tex_f1_g_x_eigen Tex_f2_g_x_c(Tex_f2_g_x_sc(Tex_f1_g_not Tex_f2_g_forall(x,
                                                                                            Tex_f2_g_forall(y,
                                                                                                            Tex3_bappl2(A,
                                                                                                                        x,
                                                                                                                        y))),
                                                               a),b) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f1_g_x_assum Tex_f1_g_not Tex_f2_g_forall(x,
                                                                          Tex_f2_g_forall(y,
                                                                                          Tex3_bappl2(A,
                                                                                                      x,
                                                                                                      y))),
                            Tex_f1_g_x_assum Tex_f1_g_not Tex3_bappl2(A,a,b),
                            Tex_f1_g_x_assum Tex_f1_g_not(Tex_f0_g_forall))
         \end
         \para where \ft a \end and \ft b \end are new variables \it  
         (eigen-variables)  \end. 
  \end

theory Sm_reflexivity logic: 'fol_def'

appldisp/2 Tex_p2_g_r
  Infix(Arg(0),25,0,Id(0,'R',0),Arg(1))

pred/2 R 'Tex_p2_g_r'

rem 
  \para \bf  Exercise.  \end Suppose that the binary relation \ft R(x,y) \end is 
  symmetric and transitive: 

axiom Symmetry
  R(x,y) -> R(y,x)

axiom Transitivity
  R(x,y) & R(y,z) -> R(x,z)

rem 
  \para Show that the relation is reflexive on its domain of definition: 

thm Reflexivity
  R(x,y) -> R(x,x)

end theory Sm_reflexivity

theory Sm_quine logic: 'fol_def'

pred A 

pred B 

pred C 

rem 
  \para \bf  Exercise.  \end Suppose that we have 

axiom Ax1
  \a x(A(x) & B(x) -> C(x)) -> \e x(A(x) & ~B(x))

axiom Ax2
  \a x(A(x) -> B(x)) \/ \a x(A(x) -> C(x))

rem 
  \para Prove the following claim: 

thm Theorem
  \a x(A(x) & C(x) -> B(x)) -> \e x(A(x) & B(x) & ~C(x))

end theory Sm_quine

